// <><><><><><><><><><><><><>  Plot3DZ.h  <><><><><><><><><><><><><><>
//
// ----------------------------------------------------
// (C) Copyright Clark Dailey, Inc. 2006
//
// Implementation of class Plot3DZ
//
// ----------------------------------------------------

#ifndef	_PLOT3DZ_H_	 	// avoid repeated including
#define	_PLOT3DZ_H_	1	// has been included

#include "plot3dt.h"


class Plot3DZ : public Plot3DT
{
	friend class CFormZ;
public:
	Plot3DZ();
	virtual ~Plot3DZ();

	// plotting
	int Plot(CWnd* pWnd);
	double Zfunc(double x,double y);
	long Color(double x,double y,double z);
	void Reset(void);
	void DefInputs();

	// load / save
	int ReadFile(void);
	int WriteFile(void);
	CString GetSurfName() { return(m_sSurfaceName); }

	// parametric equations
	double XParametric(double x,double y) { return(x); }
	double YParametric(double x,double y) { return(y); }
	double ZParametric(double x,double y) { return(Zfunc(x,y)); }
	int  InitEquations(void);

	// color info
	double RedColor  (double x,double y,double z) { return( ValidateColorValue( m_pRPlotCalc->Calc(x,y,z) ) ); }
	double GreenColor(double x,double y,double z) { return( ValidateColorValue( m_pGPlotCalc->Calc(x,y,z) ) ); }
	double BlueColor (double x,double y,double z) { return( ValidateColorValue( m_pBPlotCalc->Calc(x,y,z) ) ); }

public:	// data
	PlotCalc* m_pPlotCalc;		// Equation Calculator
	PlotCalc* m_pRPlotCalc;		// red    equation calculator
	PlotCalc* m_pGPlotCalc;		// green  equation calculator
	PlotCalc* m_pBPlotCalc;		// blue   equation calculator

private:	// user intputs
	// surface definition
	CString m_sSurfaceName;
	CString	m_zPlotEquation;
	CString	m_rPlotEquation;
	CString	m_gPlotEquation;
	CString	m_bPlotEquation;
	CString	m_sC1;
	CString	m_sC2;
	CString	m_sC3;
	CString	m_sC4;
	CString	m_sC5;
	CString	m_sC6;
	CString	m_sC7;
	CString	m_sC8;
	int m_limit_z;
};

#endif	/* if _PLOT3DZ_H_ included */

/*	<><><><><><><><><><><><><>  Plot3DZ.h  <><><><><><><><><><><><><><> */
